package cn.idaddy.open.demo.common.ui;

import javafx.application.Platform;
import javafx.geometry.Side;
import javafx.scene.Node;
import javafx.scene.control.ContextMenu;
import javafx.scene.control.MenuItem;

/**
 * Created by chenpeng on 28/06/2017.
 */
public class ErrorBox {
    final ContextMenu error = new ContextMenu();
    {
        error.setAutoHide(false);
        error.getStyleClass().add("error");

    }
    public ErrorBox(){
    }

    public void show(Node anchor,String msg){
        Platform.runLater(() -> {
            error.getItems().clear();
            MenuItem item=new MenuItem(msg);
            item.getStyleClass().add("error");
            error.getItems().add(item);
            error.show(anchor, Side.RIGHT, 10, 0);
            anchor.focusedProperty().addListener(
                    (arg0, oldPropertyValue, newPropertyValue) -> {
                        if (newPropertyValue) {
                            // Hiding the error message
                            error.hide();
                        }
                    });
        });

    }
}
