package cn.idaddy.open.demo.service;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.time.Clock;
import java.time.Instant;
import java.util.Random;

public class AppSign {
	private String app_id;
	private String app_secert;
	private long timestamp;
	private String signature;
	private String nonce;
	public String getApp_id() {
		return app_id;
	}

	public String getApp_secert() {
		return app_secert;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public String getSignature() {
		return signature;
	}

	public String getNonce() {
		return nonce;
	}

	public static Random getRandom() {
		return random;
	}
	private static Random random = new Random();
	public static AppSign sign(String app_id, String app_secert,Clock clock) {
		Instant now = clock.instant();
		AppSign result=new AppSign();
		result.app_id = app_id;
		result.app_secert = app_secert;
		result.timestamp=now.getEpochSecond();
		result.signature=sha1(String.format("%s%s%s",app_id,app_secert,result.timestamp));
		result.nonce=""+now.getNano();
		return  result;
	}

	public static String sha1(String input) {
		MessageDigest mDigest=null;
		try {
			mDigest = MessageDigest.getInstance("SHA1");
		} catch (NoSuchAlgorithmException e) {
			throw new RuntimeException("bug:"+e.getMessage(),e);
		}
		byte[] result = mDigest.digest(input.getBytes());
		return byteArrayToHex(result);
	}
	private static String byteArrayToHex(byte[] a) {
		StringBuilder sb = new StringBuilder(a.length * 2);
		for (byte b : a) sb.append(String.format("%02x", b));
		return sb.toString();
	}
	@Override
	public String toString() {
		return String.format("{app_id:%s,app_secert:%s,timestamp:%s,signature:%s,nonce:%s}", app_id,app_secert,timestamp,signature,nonce);
	}
	
}
