package cn.idaddy.open.demo;

import static org.junit.Assert.assertEquals;

import java.net.MalformedURLException;

import org.junit.Test;

import cn.idaddy.open.demo.service.OpenService;

public class TestDeviceToken {
	/*
	接入方获取到原始音频url(http://cdn.open.idaddy.cn/a...001.mp3)后，不能立即使用资源，须先为资源授权，而后才能访问，授权方式为：
	为url拼接一个名为“token”的查询参数，最终授权后的音频资源url格式为：http://cdn.open.idaddy.cn/a...001.mp3?token={有效的device_token}
	*/
	@Test
	public void token() throws MalformedURLException {
		assertEquals("http://open.idaddy.cn/a/b/c.mp3?token=xxxxxx",
				OpenService.addDeviceToken("http://open.idaddy.cn/a/b/c.mp3","xxxxxx"));
	}


	

}
